Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JTextArea

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.text.JTextComponent
                              |
                              +--javax.swing.JTextArea

public class JTextArea
extends JTextComponent

A TextArea is a multi-line area that displays plain text. It is intended to be a lightweight component that provides source compatibility with the java.awt.TextArea class where it can reasonably do so. This component has capabilities not found in the java.awt.TextArea class. The superclass should be consulted for additional capabilities. Alternative multi-line text classes with more capabilitites are JTextPane and JEditorPane.

The java.awt.TextArea internally handles scrolling. JTextArea is different in that it doesn't manage scrolling, but implements the swing Scrollable interface. This allows it to be placed inside a JScrollPane if scrolling behavior is desired, and used directly if scrolling is not desired.

The java.awt.TextArea has the ability to do line wrapping. This was controlled by the horizontal scrolling policy. Since scrolling is not done by JTextArea directly, backward compatibility must be provided another way. JTextArea has a bound property for line wrapping that controls whether or not it will wrap lines.

The java.awt.TextArea could be monitored for changes by adding a TextListener for TextEvent's. In the JTextComponent based components, changes are broadcasted from the model via a DocumentEvent to DocumentListeners. The DocumentEvent gives the location of the change and the kind of change if desired. The code fragment might look something like:

        DocumentListener myListener = ??;
        JTextArea myArea = ??;
        myArea.getDocument().addDocumentListener(myListener);

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JTextArea key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `JTextPane`, `JEditorPane`, Serialized Form

Inner Class Summary
`protected class` | `JTextArea.AccessibleJTextArea` The class used to obtain the accessible role for this object.

Inner classes inherited from class javax.swing.text.JTextComponent
`JTextComponent.AccessibleJTextComponent, JTextComponent.KeyBinding`

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Fields inherited from class javax.swing.text.JTextComponent
`DEFAULT_KEYMAP, FOCUS_ACCELERATOR_KEY`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JTextArea()` Constructs a new TextArea.
`JTextArea(Document doc)` Constructs a new JTextArea with the given document model, and defaults for all of the other arguments (null, 0, 0).
`JTextArea(Document doc, java.lang.String text, int rows, int columns)` Constructs a new JTextArea with the specified number of rows and columns, and the given model.
`JTextArea(int rows, int columns)` Constructs a new empty TextArea with the specified number of rows and columns.
`JTextArea(java.lang.String text)` Constructs a new TextArea with the specified text displayed.
`JTextArea(java.lang.String text, int rows, int columns)` Constructs a new TextArea with the specified text and number of rows and columns.

Method Summary
`void` | `append(java.lang.String str)` Appends the given text to the end of the document.
`protected Document` | `createDefaultModel()` Creates the default implementation of the model to be used at construction if one isn't explicitly given.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JTextArea.
`int` | `getColumns()` Returns the number of columns in the TextArea.
`protected int` | `getColumnWidth()` Gets column width.
`int` | `getLineCount()` Determines the number of lines contained in the area.
`int` | `getLineEndOffset(int line)` Determines the offset of the end of the given line.
`int` | `getLineOfOffset(int offset)` Translates an offset into the components text to a line number.
`int` | `getLineStartOffset(int line)` Determines the offset of the start of the given line.
`boolean` | `getLineWrap()` Gets the line-wrapping policy of the text area.
`java.awt.Dimension` | `getPreferredScrollableViewportSize()` Returns the preferred size of the viewport if this component is embedded in a JScrollPane.
`java.awt.Dimension` | `getPreferredSize()` Returns the preferred size of the TextArea.
`protected int` | `getRowHeight()` Defines the meaning of the height of a row.
`int` | `getRows()` Returns the number of rows in the TextArea.
`boolean` | `getScrollableTracksViewportWidth()` Returns true if a viewport should always force the width of this Scrollable to match the width of the viewport.
`int` | `getScrollableUnitIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation.
`int` | `getTabSize()` Gets the number of characters used to expand tabs.
`java.lang.String` | `getUIClassID()` Returns the class ID for the UI.
`boolean` | `getWrapStyleWord()` Get the style of wrapping used if the text area is wrapping lines.
`void` | `insert(java.lang.String str, int pos)` Inserts the specified text at the specified position.
`boolean` | `isManagingFocus()` Turns off tab traversal once focus gained.
`protected java.lang.String` | `paramString()` Returns a string representation of this JTextArea.
`protected void` | `processComponentKeyEvent(java.awt.event.KeyEvent e)` Make sure that TAB and Shift-TAB events get consumed, so that awt doesn't attempt focus traversal.
`void` | `replaceRange(java.lang.String str, int start, int end)` Replaces text from the indicated start to end position with the new text specified.
`void` | `setColumns(int columns)` Sets the number of columns for this TextArea.
`void` | `setFont(java.awt.Font f)` Sets the current font.
`void` | `setLineWrap(boolean wrap)` Sets the line-wrapping policy of the text area.
`void` | `setRows(int rows)` Sets the number of rows for this TextArea.
`void` | `setTabSize(int size)` Sets the number of characters to expand tabs to.
`void` | `setWrapStyleWord(boolean word)` Set the style of wrapping used if the text area is wrapping lines.

Methods inherited from class javax.swing.text.JTextComponent
`addCaretListener, addKeymap, copy, cut, fireCaretUpdate, getActions, getCaret, getCaretColor, getCaretPosition, getDisabledTextColor, getDocument, getFocusAccelerator, getHighlighter, getKeymap, getKeymap, getMargin, getScrollableBlockIncrement, getScrollableTracksViewportHeight, getSelectedText, getSelectedTextColor, getSelectionColor, getSelectionEnd, getSelectionStart, getText, getText, getUI, isEditable, isFocusTraversable, isOpaque, loadKeymap, modelToView, moveCaretPosition, paste, read, removeCaretListener, removeKeymap, removeNotify, replaceSelection, select, selectAll, setCaret, setCaretColor, setCaretPosition, setDisabledTextColor, setDocument, setEditable, setEnabled, setFocusAccelerator, setHighlighter, setKeymap, setMargin, setOpaque, setSelectedTextColor, setSelectionColor, setSelectionEnd, setSelectionStart, setText, setUI, updateUI, viewToModel, write`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusCycleRoot, isLightweightComponent, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JTextArea

    public JTextArea()

  Constructs a new TextArea. A default model is set, the initial string is null, and rows/columns are set to 0.

### JTextArea

    public JTextArea(java.lang.String text)

  Constructs a new TextArea with the specified text displayed. A default model is created and rows/columns are set to 0.
  Parameters:
    `text` - the text to be displayed, or null

### JTextArea

    public JTextArea(int rows,
                     int columns)

  Constructs a new empty TextArea with the specified number of rows and columns. A default model is created, and the initial string is null.
  Parameters:
    `rows` - the number of rows >= 0
    `columns` - the number of columns >= 0

### JTextArea

    public JTextArea(java.lang.String text,
                     int rows,
                     int columns)

  Constructs a new TextArea with the specified text and number of rows and columns. A default model is created.
  Parameters:
    `text` - the text to be displayed, or null
    `rows` - the number of rows >= 0
    `columns` - the number of columns >= 0

### JTextArea

    public JTextArea(Document doc)

  Constructs a new JTextArea with the given document model, and defaults for all of the other arguments (null, 0, 0).
  Parameters:
    `doc` - the model to use

### JTextArea

    public JTextArea(Document doc,
                     java.lang.String text,
                     int rows,
                     int columns)

  Constructs a new JTextArea with the specified number of rows and columns, and the given model. All of the constructors feed through this constructor.
  Parameters:
    `doc` - the model to use, or create a default one if null
    `text` - the text to be displayed, null if none
    `rows` - the number of rows >= 0
    `columns` - the number of columns >= 0

Method Detail

### getUIClassID

    public java.lang.String getUIClassID()

  Returns the class ID for the UI.
  Returns:
    the ID ("TextAreaUI")
  Overrides:
    getUIClassID in class JComponent
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### createDefaultModel

    protected Document createDefaultModel()

  Creates the default implementation of the model to be used at construction if one isn't explicitly given. A new instance of PlainDocument is returned.
  Returns:
    the default document model

### setTabSize

    public void setTabSize(int size)

  Sets the number of characters to expand tabs to. This will be multiplied by the maximum advance for variable width fonts. A PropertyChange event ("TabSize") is fired when the tab size changes.
  Parameters:
    `size` - number of characters to expand to
  See Also:
    `getTabSize()`

### getTabSize

    public int getTabSize()

  Gets the number of characters used to expand tabs. If the document is null or doesn't have a tab setting, return a default of 8.
  Returns:
    the number of characters

### setLineWrap

    public void setLineWrap(boolean wrap)

  Sets the line-wrapping policy of the text area. If set to true the lines will be wrapped if they are too long to fit within the allocated width. If set to false, the lines will always be unwrapped. A PropertyChange event ("LineWrap") is fired when the policy is changed.
  Parameters:
    `wrap` - indicates if lines should be wrapped.
  See Also:
    `getLineWrap()`

### getLineWrap

    public boolean getLineWrap()

  Gets the line-wrapping policy of the text area. If set to true the lines will be wrapped if they are too long to fit within the allocated width. If set to false, the lines will always be unwrapped.

### setWrapStyleWord

    public void setWrapStyleWord(boolean word)

  Set the style of wrapping used if the text area is wrapping lines. If set to true the lines will be wrapped at word boundries (ie whitespace) if they are too long to fit within the allocated width. If set to false, the lines will be wrapped at character boundries.
  Parameters:
    `word` - indicates if word boundries should be used for line wrapping.
  See Also:
    `getWrapStyleWord()`

### getWrapStyleWord

    public boolean getWrapStyleWord()

  Get the style of wrapping used if the text area is wrapping lines. If set to true the lines will be wrapped at word boundries (ie whitespace) if they are too long to fit within the allocated width. If set to false, the lines will be wrapped at character boundries.

### getLineOfOffset

    public int getLineOfOffset(int offset)
                        throws BadLocationException

  Translates an offset into the components text to a line number.
  Parameters:
    `offset` - the offset >= 0
  Returns:
    the line number >= 0
  Throws:
    BadLocationException - thrown if the offset is less than zero or greater than the document length.

### getLineCount

    public int getLineCount()

  Determines the number of lines contained in the area.
  Returns:
    the number of lines >= 0

### getLineStartOffset

    public int getLineStartOffset(int line)
                           throws BadLocationException

  Determines the offset of the start of the given line.
  Parameters:
    `line` - the line number to translate >= 0
  Returns:
    the offset >= 0
  Throws:
    BadLocationException - thrown if the line is less than zero or greater or equal to the number of lines contained in the document (as reported by getLineCount).

### getLineEndOffset

    public int getLineEndOffset(int line)
                         throws BadLocationException

  Determines the offset of the end of the given line.
  Parameters:
    `line` - the line >= 0
  Returns:
    the offset >= 0
  Throws:
    BadLocationException - Thrown if the line is less than zero or greater or equal to the number of lines contained in the document (as reported by getLineCount).

### insert

    public void insert(java.lang.String str,
                       int pos)

  Inserts the specified text at the specified position. Does nothing if the model is null or if the text is null or empty.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Parameters:
    `str` - the text to insert
    `pos` - the position at which to insert >= 0
  Throws:
    java.lang.IllegalArgumentException - if pos is an invalid position in the model
  See Also:
    `TextComponent.setText(java.lang.String)`, `replaceRange(java.lang.String, int, int)`

### append

    public void append(java.lang.String str)

  Appends the given text to the end of the document. Does nothing if the model is null or the string is null or empty.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Parameters:
    `str` - the text to insert
  See Also:
    `insert(java.lang.String, int)`

### replaceRange

    public void replaceRange(java.lang.String str,
                             int start,
                             int end)

  Replaces text from the indicated start to end position with the new text specified. Does nothing if the model is null. Simply does a delete if the new string is null or empty.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Parameters:
    `str` - the text to use as the replacement
    `start` - the start position >= 0
    `end` - the end position >= start
  Throws:
    java.lang.IllegalArgumentException - if part of the range is an invalid position in the model
  See Also:
    `insert(java.lang.String, int)`, `replaceRange(java.lang.String, int, int)`

### isManagingFocus

    public boolean isManagingFocus()

  Turns off tab traversal once focus gained.
  Returns:
    true, to indicate that the focus is being managed
  Overrides:
    isManagingFocus in class JComponent

### processComponentKeyEvent

    protected void processComponentKeyEvent(java.awt.event.KeyEvent e)

  Make sure that TAB and Shift-TAB events get consumed, so that awt doesn't attempt focus traversal.
  Overrides:
    processComponentKeyEvent in class JTextComponent

### getRows

    public int getRows()

  Returns the number of rows in the TextArea.
  Returns:
    the number of rows >= 0

### setRows

    public void setRows(int rows)

  Sets the number of rows for this TextArea. Calls invalidate() after setting the new value.
  Parameters:
    `rows` - the number of rows >= 0
  Throws:
    java.lang.IllegalArgumentException - if rows is less than 0
  See Also:
    `getRows()`

### getRowHeight

    protected int getRowHeight()

  Defines the meaning of the height of a row. This defaults to the height of the font.
  Returns:
    the height >= 1

### getColumns

    public int getColumns()

  Returns the number of columns in the TextArea.
  Returns:
    number of columns >= 0

### setColumns

    public void setColumns(int columns)

  Sets the number of columns for this TextArea. Does an invalidate() after setting the new value.
  Parameters:
    `columns` - the number of columns >= 0
  Throws:
    java.lang.IllegalArgumentException - if columns is less than 0
  See Also:
    `getColumns()`

### getColumnWidth

    protected int getColumnWidth()

  Gets column width. The meaning of what a column is can be considered a fairly weak notion for some fonts. This method is used to define the width of a column. By default this is defined to be the width of the character m for the font used. This method can be redefined to be some alternative amount.
  Returns:
    the column width >= 1

### getPreferredSize

    public java.awt.Dimension getPreferredSize()

  Returns the preferred size of the TextArea. This is the maximum of the size needed to display the text and the size requested for the viewport.
  Returns:
    the size
  Overrides:
    getPreferredSize in class JComponent

### setFont

    public void setFont(java.awt.Font f)

  Sets the current font. This removes cached row height and column width so the new font will be reflected, and calls revalidate().
  Parameters:
    `f` - the font to use as the current font
  Overrides:
    setFont in class JComponent

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JTextArea. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JTextArea.
  Overrides:
    paramString in class JTextComponent

### getScrollableTracksViewportWidth

    public boolean getScrollableTracksViewportWidth()

  Returns true if a viewport should always force the width of this Scrollable to match the width of the viewport. This is implemented to return true if the line wrapping policy is true, and false if lines are not being wrapped.
  Returns:
    true if a viewport should force the Scrollables width to match its own.
  Overrides:
    getScrollableTracksViewportWidth in class JTextComponent

### getPreferredScrollableViewportSize

    public java.awt.Dimension getPreferredScrollableViewportSize()

  Returns the preferred size of the viewport if this component is embedded in a JScrollPane. This uses the desired column and row settings if they have been set, otherwise the superclass behavior is used.
  Returns:
    The preferredSize of a JViewport whose view is this Scrollable.
  Overrides:
    getPreferredScrollableViewportSize in class JTextComponent
  See Also:
    `JComponent.getPreferredSize()`

### getScrollableUnitIncrement

    public int getScrollableUnitIncrement(java.awt.Rectangle visibleRect,
                                          int orientation,
                                          int direction)

  Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation. This is implemented to use the vaules returned by the `getRowHeight` and `getColumnWidth` methods.

  Scrolling containers, like JScrollPane, will use this method each time the user requests a unit scroll.

  Parameters:
    `visibleRect` - the view area visible within the viewport
    `orientation` - Either SwingConstants.VERTICAL or SwingConstants.HORIZONTAL.
    `direction` - Less than zero to scroll up/left, greater than zero for down/right.
  Returns:
    The "unit" increment for scrolling in the specified direction
  Throws:
    java.lang.IllegalArgumentException - for an invalid orientation
  Overrides:
    getScrollableUnitIncrement in class JTextComponent
  See Also:
    `JScrollBar.setUnitIncrement(int)`, `getRowHeight()`, `getColumnWidth()`

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JTextArea. Creates a new context if necessary.
  Returns:
    the AccessibleContext of this JTextArea
  Overrides:
    getAccessibleContext in class JTextComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.